// CameraClientI.h: interface for the CCameraClientI class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CAMERACLIENTI_H__54744444_3BFE_4AFC_8F1D_7B9344F97358__INCLUDED_)
#define AFX_CAMERACLIENTI_H__54744444_3BFE_4AFC_8F1D_7B9344F97358__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include<netlayer.h>


class UserInfo;
class DeviceInfo;
class DeviceSeq;
class CameraClientI:public ::NetLayer::CameraClient
{
	virtual bool CheckRights(int userid,int dev_id,int dev_type,int op_id,
		const ::Ice::Current& = ::Ice::Current());
	virtual bool Login(const ::std::string& username, const ::std::string& password, NetLayer::UserInfo& userinfo,
		const ::Ice::Current& = ::Ice::Current());
	virtual bool GetDeviceById(int, int, NetLayer::DeviceInfo&,
		const ::Ice::Current& = ::Ice::Current());    
	virtual bool GetDevicesByParentId(int, int,NetLayer::DeviceSeq&,
		const ::Ice::Current& = ::Ice::Current());    		
public :
private:	
};

#endif // !defined(AFX_CAMERACLIENTI_H__54744444_3BFE_4AFC_8F1D_7B9344F97358__INCLUDED_)
