// Communicator.h: Definition of the CCommunicator class
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_COMMUNICATOR_H__9C3D9073_4553_4CC1_98E1_84C9A76129D6__INCLUDED_)
#define AFX_COMMUNICATOR_H__9C3D9073_4553_4CC1_98E1_84C9A76129D6__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "resource.h"       // main symbols
#include <NetLayer.h>

/////////////////////////////////////////////////////////////////////////////
// CCommunicator

class CCommunicator : 
	public ICommunicator, 
	public CComObjectRootEx<CComGlobalsThreadModel>,
	public CComCoClass<CCommunicator,&CLSID_Communicator>
{
public:
	CCommunicator() {
		m_bInited = false;
	}
BEGIN_COM_MAP(CCommunicator)
	COM_INTERFACE_ENTRY(ICommunicator) 
END_COM_MAP()
//DECLARE_NOT_AGGREGATABLE(CCommunicator) 
// Remove the comment from the line above if you don't want your object to 
// support aggregation. 

DECLARE_REGISTRY_RESOURCEID(IDR_Communicator)

// ICommunicator
public:
	bool Init();
	void Uninit();
	Ice::CommunicatorPtr GetCommunicator() { return _communicator;}
	NetLayer::CameraClientPrx GetProxy(){ return _proxy;}
private:
	bool m_bInited;
	Ice::CommunicatorPtr _communicator;
	NetLayer::CameraClientPrx _proxy;
};

#endif // !defined(AFX_COMMUNICATOR_H__9C3D9073_4553_4CC1_98E1_84C9A76129D6__INCLUDED_)
