// DeviceFactory.h : Declaration of the CDeviceFactory

#ifndef __DEVICEFACTORY_H_
#define __DEVICEFACTORY_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CDeviceFactory
class ATL_NO_VTABLE CDeviceFactory : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CDeviceFactory, &CLSID_DeviceFactory>,
	public IDispatchImpl<IDeviceFactory, &IID_IDeviceFactory, &LIBID_SEURITYINFOLib>
{
public:
	CDeviceFactory()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_DEVICEFACTORY)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CDeviceFactory)
	COM_INTERFACE_ENTRY(IDeviceFactory)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

// IDeviceFactory
public:
	STDMETHOD(CreateDevice)(long DeviceId,long DeviceType,IDispatch **ppDevice);
};

#endif //__DEVICEFACTORY_H_
