// Device.cpp : Implementation of CDevice
#include "stdafx.h"
#include "SeurityInfo.h"
#include "Device.h"
#include "Camera.h"
#include "Set.h"
#include <comdef.h>
#include <IceUtil/UUID.h>
#include <netlayer.h>
#include "Communicator.h"
using namespace NetLayer;
using namespace std;
using namespace Ice;
/////////////////////////////////////////////////////////////////////////////
// CDevice

extern CComObject<CCommunicator>* g_pComm;
STDMETHODIMP CDevice::get_DeviceId(long *pVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())
	*pVal = m_lDeviceId;
	// TODO: Add your implementation code here	
	return S_OK;
}

STDMETHODIMP CDevice::put_DeviceId(long newVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// TODO: Add your implementation code here
	m_lDeviceId = newVal;

	return S_OK;
}

STDMETHODIMP CDevice::get_Cameras(ISet **pVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())
	ISetPtr ipSet(CLSID_Set);	
	

	
	NetLayer::DeviceSeq devices;
	bool ret = g_pComm->GetProxy()->GetDevicesByParentId(m_lDeviceId,1,devices);
			
		
		
				
	ipSet->AddRef();
	*pVal = ipSet;
	
	

	return S_OK;
}

STDMETHODIMP CDevice::get_Description(BSTR *pVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	
	*pVal = m_strDescription.AllocSysString();
	return S_OK;
}
